#include "dcdialog.ch"
#include "dctree.ch"
#include "dcmsg.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "nls.ch"
#include "dll.ch"


procedure main
SET CHARSET TO OEM
SET CONFIRM ON
SET DELETE ON
SET SCORE OFF


DO EXAMPLE

RETURN


PROC appsys ; RETURN




PROCEDURE EXAMPLE
LOCAL GetOptions ,GetList := {}
LOCAL aPos:={0,0},aSize:={0,0}
LOCAL oButtonLev0,oButtonLev1

PRIVATE m_code,m_desc,m_aliqu,m_cconv,m_ccon2,m_regim,m_cdcee
PRIVATE oTextRegime,cTextRegime:="",oTextNatura,cTextNatura:=""
PRIVATE m_tabcode:={ "10 .. OPTION CODE 1", ;
                     "20 .. OPTION CODE 2", ;
                     "30 .. OPTION CODE 3", ;
                     "40 .. OPTION CODE 4", ;
                     "50 .. OPTION CODE 5"  }

PRIVATE m_tabreg:={ "1 .. OPTION 1", ;
                    "2 .. OPTION 2", ;
                    "3 .. OPTION 3", ;
                    "4 .. OPTION 4", ;
                    "5 .. OPTION 5"  }

PRIVATE m_vetnat:={ "N1    OPTION 1", ;
                    "N2    OPTION 2", ;
                    "N2.1  OPTION 3", ;
                    "N2.2  OPTION 4", ;
                    "N3    OPTION 5", ;
                    "N3.1  OPTION 6", ;
                    "N3.2  OPTION 7", ;
                    "N3.3  OPTION 8", ;
                    "N7    OPTION 9"  }
PRIVATE m_choose:=""

PRIVATE oDialog,oDarea

CLEAR_VAR()
m_choose:=""
lExitKey:=.F.


aSize:={ 800,500 }
aPos[1]:=10
aPos[2]:=100

oDialog := XbpDialog():New(,, aPos, aSize )
oDialog:Title := "EXAMPLE"
oDialog:minSize:=aSize
oDialog:maxSize:=aSize
oDialog:sysMenu:=.F.
oDialog:hideButton:=.F.
oDialog:border := XBPDLG_THINBORDER
oDialog:Create()

// trick to hide min,max button
oDialog:maxButton:=.F.
oDialog:minButton:=.F.
oDialog:configure()

SetAppFocus(oDialog)
oDarea:=oDialog:drawingArea


    @  1,1  DCSAY "Codice IVA       " GET m_code PICT "99" GETID "M_CODE" ;
                  VALID {|o| CHECK_COD(GetList) } ;
                  WHEN { || m_choose $ "1234" } SAYOPTION XBPSTATIC_TEXT_VCENTER ;
                  POPUP { |a,oGet| F2_List("M_CODE",oDialog,oGet),DC_GetRefresh(GetList) } POPKEY xbeK_F2

    @  2,1  DCSAY "Aliquota IVA (%) " GET m_aliqu PICT "99" GETID "M_ALIQU" ;
            VALID {|o| m_aliqu>=0 } ;
            WHEN { || m_choose $ "12" } SAYOPTION XBPSTATIC_TEXT_VCENTER

    @  3,1  DCSAY "Descrizione      " GET m_desc GETID "M_DESC" ;
            VALID {|o| !EMPTY(m_desc) } ;
            WHEN { || m_choose $ "12" } SAYOPTION XBPSTATIC_TEXT_VCENTER

    @  5,1  DCSAY "Codice Regime    " GET m_regim PICT "9" GETID "M_REGIM" ;
                  VALID {|o| CHECK_REG() } ;
                  WHEN { || m_choose $ "12" } SAYOPTION XBPSTATIC_TEXT_VCENTER

    @  6,1  DCSAY "Cod.conversione  " GET m_cconv GETID "M_CCONV" ;
            WHEN { || m_choose $ "12" } SAYOPTION XBPSTATIC_TEXT_VCENTER

    @  7,1  DCSAY "Cod.CEE          " GET m_cdcee GETID "M_CDCEE" ;
            WHEN { || m_choose $ "12" } SAYOPTION XBPSTATIC_TEXT_VCENTER

    @  8,1  DCSAY "Cod.Natura FE    " GET m_ccon2 GETID "M_CCON2" ;
                  VALID {|o| CHECK_NAT() } ;
                  WHEN { || m_choose $ "12" } SAYOPTION XBPSTATIC_TEXT_VCENTER ;
                  POPUP { |a,oGet| F2_List("M_CCON2",oDialog,oGet),DC_GetRefresh(GetList) } POPKEY xbeK_F2



    // SECONDARY PUSHBUTTONS - NORMALLY HIDE
    @ aSize[2]-65,0 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE aSize[1],40 OBJECT oButtonLev1 PIXEL ;
                             HIDE { || EMPTY(m_choose) }
    @ 0.4,1  DCPUSHBUTTON CAPTION "CONFIRM" ;
                          WHEN {||m_choose!="4"} ;
                          ACCELKEY xbeK_F12 ;
                          ACTION {|o|CONFIRM(),m_choose:="",DC_GetRefresh(GetList)} SIZE 12,1 PARENT oButtonLev1 TABSTOP

    @ 0.4,15 DCPUSHBUTTON CAPTION "CANCEL" ;
                          ACCELKEY xbeK_ESC CARGO 'CANCEL' ;
                          ACTION {|o|m_choose:="",DC_GetRefresh(GetList)} SIZE 12,1 PARENT oButtonLev1 TABSTOP



    // MAIN PUSHBUTTONS - NORMALLY ENABLED
    @ aSize[2]-65,0 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE aSize[1],40 OBJECT oButtonLev0 PIXEL ;
                             HIDE { || !EMPTY(m_choose) }

    @ 0.4,1  DCPUSHBUTTON CAPTION "INSERT" ;
                         ACTION {|o|ACTIONS("ins",GetList)} SIZE 12,1 PARENT oButtonLev0 TABSTOP
    @ 0.4,15 DCPUSHBUTTON CAPTION "MODIFY" ;
                         ACTION {|o|ACTIONS("mod",GetList)} SIZE 12,1 PARENT oButtonLev0 TABSTOP
    @ 0.4,29 DCPUSHBUTTON CAPTION "DELETE" ;
                         ACTION {|o|ACTIONS("del",GetList)} SIZE 12,1 PARENT oButtonLev0 TABSTOP
    @ 0.4,43 DCPUSHBUTTON CAPTION "VIEW  " ;
                         ACTION {|o|ACTIONS("view",GetList)} SIZE 12,1 PARENT oButtonLev0 TABSTOP
    @ 0.4,57 DCPUSHBUTTON CAPTION "EXIT  " ID "1PULS" ;
                         ACTION {||lExitKey:=.T.,DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} SIZE 12,1 PARENT oButtonLev0 TABSTOP


    DCGETOPTIONS NOBUSY CONFIRM NOMINBUTTON NOMAXBUTTON NOTASKLIST NORESIZE


DO WHILE .T.


    DCREAD GUI TO lStatus OPTIONS GetOptions PARENT oDarea SETFOCUS "1PULS"  ;
               SAVE ;      // <--------------------- EXIT AND RETAIN GETs
               ENTEREXIT ; // <------------------------------------------------ ENTER ON LAST GET CAUSE EXIT LOOP


    IF lExitKey // <---------- PRESS EXIT PUSHBUTTON
        EXIT
    ENDIF
    IF lStatus  // <---------- .T. IF DCGUI_EXIT_OK
        CONFIRM()
    ENDIF

    m_choose:=""
    DC_GetRefresh(GetList)

ENDDO

RETURN





******************************************************************************
* FUNCTION  ACTIONS()
******************************************************************************
STATIC FUNCTION ACTIONS (cChoose,GetList)
DO CASE
CASE cChoose=="ins"
    m_choose:="1"
    CLEAR_VAR()

CASE cChoose=="mod"
    m_choose:="2"

CASE cChoose=="del"
    m_choose:="3"

CASE cChoose=="view"
    m_choose:="4"

ENDCASE
DC_GetRefresh(GetList)
SetAppFocus(DC_GETOBJECT(GetList,"M_CODE"))
RETURN NIL



******************************************************************************
* FUNCTION  CONFIRM()
******************************************************************************
STATIC FUNCTION CONFIRM
DCMSGBOX  "SAVE DATA routine"
RETURN NIL





******************************************************************************
* FUNCTION  CLEAR_VAR()
******************************************************************************
STATIC FUNCTION CLEAR_VAR
m_code:=SPACE(2)
m_desc:=SPACE(50)
m_aliqu:=0
m_cconv:=m_ccon2:=m_cdcee:=SPACE(5)
m_regim:=SPACE(1)
RETURN NIL




******************************************************************************
* FUNCTION  CHECK_COD()
******************************************************************************
STATIC FUNCTION CHECK_COD (GetList)
LOCAL f_ret:=.F.
IF !EMPTY(m_code)
    FOR f_t:=1 TO LEN(m_tabcode)
        IF LEFT(m_tabcode[f_t],2)==m_code
            f_ret:=.T.
            IF m_choose=="1"
                DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) // force ESC
            ENDIF
            EXIT
        ENDIF
    NEXT
    IF !f_ret.AND.m_choose=="1" // New code = insert
        f_ret:=.T.
    ENDIF
ENDIF
RETURN f_ret



******************************************************************************
* FUNCTION  CHECK_REG()
* Controllo codice registri
******************************************************************************
STATIC FUNCTION CHECK_REG
LOCAL f_t,f_ret:=.F.
IF !EMPTY(m_regim)
    FOR f_t:=1 TO LEN(m_tabreg)
        IF LEFT(m_tabreg[f_t],1)==m_regim
            f_ret:=.T.
            EXIT
        ENDIF
    NEXT
ENDIF
RETURN f_ret



******************************************************************************
* FUNCTION  CHECK_NAT()
* Controllo codice natura
******************************************************************************
STATIC FUNCTION CHECK_NAT
LOCAL f_t,f_ret:=.F.
IF !EMPTY(m_ccon2)
    FOR f_t:=1 TO LEN(m_vetnat)
        IF LEFT(m_vetnat[f_t],5)==m_ccon2
            f_ret:= RIGHT( m_vetnat[f_t], LEN(m_vetnat[f_t])-6 )
            f_ret:=.T.
            EXIT
        ENDIF
    NEXT
ELSE
    f_ret:=.T.
ENDIF
RETURN f_ret






******************************************************************************
* FUNCTION  F2_List()
******************************************************************************
STATIC FUNCTION F2_List (cVar,oDlg,oGet)
LOCAL GetOptions ,GetList:={}
LOCAL aPos:={0,0},aSize:={0,0},nDimCol,nDimRow
LOCAL aVar:={},aPerso:={}
LOCAL oWindow,oBrowse,cAlias,oColumn,oFocus

DO CASE
CASE cVar=="M_CODE"

    oFocus:=SetAppFocus( oDlg )

    // Dimensione browse
    nDimCol:=68
    nDimRow:=15
    @ 0,0 DCLISTBOX aVar LIST m_tabcode SIZE nDimCol,nDimRow MARKMODE XBPLISTBOX_MM_SINGLE ;
          ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} OBJECT oColumn

    DCGETOPTIONS CONFIRM NORESIZE NOTASKLIST HIDE

    DCREAD GUI TITLE "List of codes" ADDBUTTONS OPTIONS GetOptions FIT MODAL SETFOCUS @oColumn  OWNER oDlg EVAL {|o|SetBrowsePosF2(o,oGet)}

    IF LEN(aVar)>0
        m_code:=LEFT(aVar[1],2)
    ENDIF

    SetAppFocus( oFocus )



CASE cVar=="M_REGIM"

    oFocus:=SetAppFocus( oDlg )

    // Dimensione browse
    nDimCol:=35
    nDimRow:=LEN(m_tabreg)
    @ 0,0 DCLISTBOX aVar LIST m_tabreg SIZE nDimCol,nDimRow MARKMODE XBPLISTBOX_MM_SINGLE ;
          ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} OBJECT oColumn

    DCGETOPTIONS CONFIRM NORESIZE NOTASKLIST HIDE

    DCREAD GUI TITLE "List of Regimi IVA" ADDBUTTONS OPTIONS GetOptions FIT MODAL SETFOCUS @oColumn OWNER oDlg EVAL {|o|SetBrowsePosF2(o,oGet)}


    IF LEN(aVar)>0
        m_regim:=LEFT(aVar[1],1)
        CHECK_REG()
    ENDIF

    SetAppFocus( oFocus )



CASE cVar=="M_CCON2"

    oFocus:=SetAppFocus( oDlg )

    // Dimensione browse
    nDimCol:=55
    nDimRow:=15
    @ 0,0 DCLISTBOX aVar LIST m_vetnat SIZE nDimCol,nDimRow MARKMODE XBPLISTBOX_MM_SINGLE ;
          ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} OBJECT oColumn

    DCGETOPTIONS CONFIRM  NORESIZE NOTASKLIST HIDE

    DCREAD GUI TITLE "List of Natura FE" ADDBUTTONS OPTIONS GetOptions FIT MODAL SETFOCUS @oColumn OWNER oDlg EVAL {|o|SetBrowsePosF2(o,oGet)}


    IF LEN(aVar)>0
        m_ccon2:=LEFT(aVar[1],5)
        CHECK_NAT()
    ENDIF

    SetAppFocus( oFocus )


ENDCASE
RETURN NIL


/******************
 *  SetBrowsePosF2( oDialog,oGetList )  Positioning after button F2
 ********************************************************************/
FUNCTION SetBrowsePosF2 (oDlg,oGet)
LOCAL aPos

aPos := DC_CALCABSOLUTEPOSITION({0,0},oGet)
oDlg:setPos( { aPos[1], aPos[2]-oDlg:currentSize()[2]+10 } )
oDlg:show()
RETURN NIL

